require("util")
require("defines")
local function build_gui(a)
	if a == "energy_condenser" then
		if game.player.gui.left.EE_energy_condenser == nil then
		game.player.print("creating guis...")
			game.player.gui.left.add{type="frame", name="EE_energy_condenser", caption="Energy condenser", style='frame_style', direction='vertical'}
			game.player.gui.left.EE_energy_condenser.add{type="flow", name="EE_flow_item_selector", direction="horizontal"}
			game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.add{type="button", name="EE_item_selector_button", caption="Select item in hand"}
			game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.add{type="label", name="EE_label_item_selector", caption="no item selected"}
			game.player.gui.left.EE_energy_condenser.add{type="flow", name="EE_flow_progressbar", direction="vertical"}
			game.player.gui.left.EE_energy_condenser.EE_flow_progressbar.add{type="label", name="EE_label_progressbar", caption="EMC"}
			game.player.gui.left.EE_energy_condenser.EE_flow_progressbar.add{type="progressbar", name="EE_progress_EMC", size="100"}
		end
	end
end

local function destroy_gui(a)
	if a == "energy_condenser" then
		if game.player.gui.left.EE_energy_condenser then
			game.player.print("destroying guis...")
			game.player.gui.left.EE_energy_condenser.destroy()
		else
			game.player.print("not destroying guis")
		end
	end
end

local function selectitem(a)
	if game.player.cursor_stack.valid_for_read == true then
		if game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption == "no item selected" then
			--what to do when there is no item selected
			if game.player.cursor_stack.count == 0 then
				--what to do when there also is no item in hand(do nothing)
			else
				--what to do when there is an item in hand(set the item in the label and take on out of hand)
				game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption = game.player.cursor_stack.name
				game.player.cursor_stack.count = game.player.cursor_stack.count - 1
			end
		else
			--what to do if there already is an item selected
			if game.player.cursor_stack.name == game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption then
				--if the item in hand is the same as the item in the caption(add one to hand and set the caption back to "no item selected")
				game.player.cursor_stack.count = game.player.cursor_stack.count + 1
				game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption = "no item selected"
			else
				--if the item in hand is different as the name in the label(add the item in the label to the inv and set the label to the good name and take one off the in hand stack)
				game.player.print("the code has arrived at checking the inventory placement possibillity's")
				if game.player.can_insert{name = game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption, count = 1} == "true" then
				--this does not seem to work
					game.player.print("player inv has space left")
					game.player.insert{name = game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption, count = 1}
					game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption = game.player.cursor_stack.name
					game.player.cursor_stack.count = game.player.cursor_stack.count - 1
				else
					--if the item cannot be inserted into the user inventory
					game.player.print("the player inventory seems to be full")
					if game.player.opened.inventory.can_insert{name = game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption, count = 1} == true then
						game.player.opened.inventory.insert{name = game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption, count = 1}
						game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector = game.player.cursor_stack.name
						game.player.cursor_stack.count = game.player.cursor_stack.count - 1
					else
						--if the item also cannot be inserted into the Energy condenser(drop the item on the floor)
						--make the item into EMC
						game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption = game.player.cursor_stack.name
						game.player.cursor_stack.count = game.player.cursor_stack.count - 1
					end
				end
			end
		end
	else
		--what to do if the hand is empty
		if game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption ~= "no item selected" then
			--if the item is to be placed back into the hand
			game.player.cursor_stack.set_stack{name = game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption, count = 1}
			game.player.gui.left.EE_energy_condenser.EE_flow_item_selector.EE_label_item_selector.caption = "no item selected"
		else
			--if the button is pressed with hand and caption empty(do nothing)
		end
	end
end

game.on_event(defines.events.on_gui_click, function(event)
	if (event.element.name == "EE_item_selector_button") then
		selectitem()
	end
 end)

game.on_event(defines.events.on_tick, function(event)
	if game.player.opened == nil then
		a = "energy_condenser"
		destroy_gui(a)
	elseif game.player.opened.name == "energycondenser" then
		a = "energy_condenser"
		build_gui(a)
	end
end)